#!C:\Programme\Python25\python.exe
# -*- coding: UTF-8 -*-
import os, sys,  subprocess
from os.path import *
from xml.dom.minidom import parse

# ***** include the biocase.lib directory in the python sys path for importing *****
#execfile('/Workspace/bps2/lib/biocase/adjustpath.py')
execfile( os.path.abspath( os.path.join( os.path.dirname( __file__ ), os.pardir, os.pardir, 'lib', 'biocase', 'adjustpath.py' ) ))

from biocase.configtool.general import *
import simplejson as json
import biocase.configuration

schema = 'DwCA'
dsa = 'pontaurus'
action = 'archiveexists'

dsa = form.getvalue('dsa')
schema = form.getvalue('schema')
action = form.getvalue("action")

archivePath = join(unicode(cfg.archiveWorkLocator), dsa) + os.sep
dldPath =join(unicode(cfg.archiveDownloadLocator), dsa) + os.sep
proc_dwca = archivePath + "DwCA.proc"
log_dwca = archivePath + "DwCA.log"
if schema is not None:
    config = archivePath + schema + ".config.xml"
    proc_xml = archivePath + schema + ".proc"
    log = archivePath + schema + ".log"
    faf = dldPath + schema + '.zip'

print('Content-Type: text/html\n')

# Print 25 last lines of log files
if action == "showlog":
    # First, print log
    if exists(log):
        size = getsize(log)
        f = open(log)
        # Only read 4KB at the end
        f.seek(max(size-4096, 0))
        lines = f.readlines()
        # Add line that indicates finishing
        if not exists(proc_xml):
            if exists(proc_dwca):
                lines.append("XML generation ended, conversion will be started...")
            else:
                lines.append("... processing ended.")
        # Restrict output to 25 lines
        if len(lines) > 25:
            print "(continued)"
        for line in lines[-25:]:
            print line,
        f.close()
    else:		
        print("Log file not found: " + log)

if action == "archiveexists":
    if exists(join(dldPath, schema + '.log')):
        print "true"
    else:
        print "false"

if action == "list":
    ret = {}
    dwca_running = os.path.exists(proc_dwca)

    # First, browse the download folder
    # do not include DwCAs if there is currently a DwCA creation running!
    l = os.listdir(dldPath)
    for fname in l:
        if fname.endswith("dwca.zip"):
            if not dwca_running:
                ret[fname[:-4]] = 'dwca'
        elif fname.endswith(".zip"):
            ret[fname[:-4]] = 'xml:' + fname[:-4]

    # Then, check for proc files
    l = os.listdir(archivePath)
    for fname in l:
        if fname.endswith('.proc'):
            fname_head = splitext(fname)[0]
            if fname == split(proc_dwca)[1]:
                ret[fname_head] = 'proc:dwca'
            else:
                ret[fname_head] = 'proc:xml'

    # Last, log files of aborted runs
    l = os.listdir(archivePath)
    for fname in l:
        if fname.endswith('.log'):
            fname_head = splitext(fname)[0]
            addit = False

            # Ignore empty files
            if getsize(join(archivePath, fname)) > 0:
                if exists(join(dldPath, fname)):
                    # Same file exists in download folder: Only list if it's not the same file
                    a = os.stat(join(archivePath, fname))
                    d = os.stat(join(dldPath, fname))
                    if (a.st_size != d.st_size) or (d.st_mtime - a.st_mtime > 5):
                        addit = True
                else:
                    # Doesn't exist in download folder: add to list
                    addit = True

            # Check if it's running: don't add
            if fname_head in ret:
                if ret[fname_head].startswith('proc:'):
                    addit = False

            # Add * to name in order not to overwrite the finished entry
            if addit:
                ret['*' + fname_head] = 'log'

    # Return dictionary as JSON
    print json.dumps(ret)

if action == "remove":
    try:
        filename = unicode(form.getvalue('filename'), 'utf-8')
        fromworkfolder = form.getvalue('fromworkfolder')

        # If failed logs are to be removed: easy
        if fromworkfolder == 'true':
            os.remove(archivePath + filename + '.log')
            print "Log file was removed"

        else:
            # First, remove archive file from download folder
            if exists(dldPath + filename + '.zip'):
                os.remove(dldPath + filename + '.zip')
                print unicode.encode(filename + '.zip' + " was removed.", 'utf-8')
            else:
                print unicode.encode(filename + '.zip' + " does not exist.", 'utf-8')

            # Set logfile name
            if filename.endswith('dwca'):
                dwnldLog = join(dldPath, "DwCA.log")
                archiveLog = join(archivePath, "DwCA.log")
            else:
                dwnldLog = join(dldPath, filename + '.log')
                archiveLog = join(archivePath, filename + '.log')
                # and remove config file
                dwnldCfg = join(dldPath, filename + '.config.xml')
                if exists(dwnldCfg):
                    os.remove(dwnldCfg)

            # Delete log from download and archive folder
            if exists(dwnldLog):
                os.remove(dwnldLog)
            if exists(archiveLog):
                os.remove(archiveLog)

    except Exception, err:
        print err
